# -*- coding: utf-8 -*-

from recc.variables.database import (
    TABLE_USER,
    TABLE_GROUP,
    TABLE_PERMISSION,
    TABLE_PROJECT,
    TABLE_TASK,
    TABLE_LAYOUT,
    TABLE_WIDGET,
    INDEX_USER_NAME,
    INDEX_USER_EMAIL,
    INDEX_GROUP_NAME,
    INDEX_PERMISSION_NAME,
    INDEX_PROJECT_NAME,
    INDEX_TASK_NAME,
    INDEX_LAYOUT_NAME,
    INDEX_WIDGET_NAME,
)

CREATE_INDEX_USER_NAME = f"""
CREATE INDEX IF NOT EXISTS {INDEX_USER_NAME}
ON {TABLE_USER} (username);
"""

CREATE_INDEX_USER_EMAIL = f"""
CREATE INDEX IF NOT EXISTS {INDEX_USER_EMAIL}
ON {TABLE_USER} (email);
"""

CREATE_INDEX_GROUP_NAME = f"""
CREATE INDEX IF NOT EXISTS {INDEX_GROUP_NAME}
ON {TABLE_GROUP} (name);
"""

CREATE_INDEX_PERMISSION_NAME = f"""
CREATE INDEX IF NOT EXISTS {INDEX_PERMISSION_NAME}
ON {TABLE_PERMISSION} (name);
"""

CREATE_INDEX_PROJECT_NAME = f"""
CREATE INDEX IF NOT EXISTS {INDEX_PROJECT_NAME}
ON {TABLE_PROJECT} (name);
"""

CREATE_INDEX_TASK_NAME = f"""
CREATE INDEX IF NOT EXISTS {INDEX_TASK_NAME}
ON {TABLE_TASK} (name);
"""

CREATE_INDEX_LAYOUT_NAME = f"""
CREATE INDEX IF NOT EXISTS {INDEX_LAYOUT_NAME}
ON {TABLE_LAYOUT} (name);
"""

CREATE_INDEX_WIDGET_NAME = f"""
CREATE INDEX IF NOT EXISTS {INDEX_WIDGET_NAME}
ON {TABLE_WIDGET} (name);
"""

CREATE_INDICES = (
    CREATE_INDEX_USER_NAME,
    CREATE_INDEX_USER_EMAIL,
    CREATE_INDEX_GROUP_NAME,
    CREATE_INDEX_PERMISSION_NAME,
    CREATE_INDEX_PROJECT_NAME,
    CREATE_INDEX_TASK_NAME,
    CREATE_INDEX_LAYOUT_NAME,
    CREATE_INDEX_WIDGET_NAME,
)

DROP_INDEX_USER_NAME = f"DROP INDEX IF EXISTS {INDEX_USER_NAME};"
DROP_INDEX_USER_EMAIL = f"DROP INDEX IF EXISTS {INDEX_USER_EMAIL};"
DROP_INDEX_GROUP_NAME = f"DROP INDEX IF EXISTS {INDEX_GROUP_NAME};"
DROP_INDEX_PERMISSION_NAME = f"DROP INDEX IF EXISTS {INDEX_PERMISSION_NAME};"
DROP_INDEX_PROJECT_NAME = f"DROP INDEX IF EXISTS {INDEX_PROJECT_NAME};"
DROP_INDEX_TASK_NAME = f"DROP INDEX IF EXISTS {INDEX_TASK_NAME};"
DROP_INDEX_LAYOUT_NAME = f"DROP INDEX IF EXISTS {INDEX_LAYOUT_NAME};"
DROP_INDEX_WIDGET_NAME = f"DROP INDEX IF EXISTS {INDEX_WIDGET_NAME};"

DROP_INDICES = (
    DROP_INDEX_USER_NAME,
    DROP_INDEX_USER_EMAIL,
    DROP_INDEX_GROUP_NAME,
    DROP_INDEX_PERMISSION_NAME,
    DROP_INDEX_PROJECT_NAME,
    DROP_INDEX_TASK_NAME,
    DROP_INDEX_LAYOUT_NAME,
    DROP_INDEX_WIDGET_NAME,
)
